import h5py # http://www.h5py.org/
import numpy as np
import sys


fileIn = "/data/slmet/slmet111/met_data/ecmwf/era5/netcdf4/2017/2017090100_ml.nc"
fileOut = "./coordinates.h5"
# open hdf5 file
fIn = h5py.File(fileIn, "r")
# create hdf5 file
fOut = h5py.File(fileOut, 'w')

latIn = fIn['/lat'] # open one attribute to get the sizes
lonIn = fIn['/lon'] # open one attribute to get the sizes
levIn = fIn['/lev_2'] # open one attribute to get the sizes
#print latIn[:]
#print lonIn[:]
#print levIn[:]

#print dset.size
#print dset.dims
print "dataset is of size lat=%d, lon=%d, lev=%d" % ( latIn.shape[0], lonIn.shape[0], levIn.shape[0])

xOut = fOut.create_dataset("/x", (levIn.shape[0], latIn.shape[0], lonIn.shape[0]), dtype=np.float32)
yOut = fOut.create_dataset("/y", (levIn.shape[0], latIn.shape[0], lonIn.shape[0]), dtype=np.float32)
zOut = fOut.create_dataset("/z", (levIn.shape[0], latIn.shape[0], lonIn.shape[0]), dtype=np.float32)

lat = np.zeros((latIn.shape[0], lonIn.shape[0]), dtype = np.float32)
lon = np.zeros((latIn.shape[0], lonIn.shape[0]), dtype = np.float32)
for i in range(lonIn.shape[0]):
  lat[:, i] = latIn

for i in range(latIn.shape[0]):
  lon[i, :] = lonIn

x = np.zeros((latIn.shape[0], lonIn.shape[0]), dtype = np.float32)
y = np.zeros((latIn.shape[0], lonIn.shape[0]), dtype = np.float32)
z = np.zeros((latIn.shape[0], lonIn.shape[0]), dtype = np.float32)
for i in range(levIn.shape[0]):
  print "calculating coordinates for level %d" % (i)
  height = (137.0 - levIn[i])*.5+150
  x = height * np.cos(lat*3.14/180)*np.cos(lon*3.14/180*1.002)
  y = height * np.cos(lat*3.14/180)*np.sin(lon*3.14/180*1.002)
  z = height * np.sin(lat*3.14/180)
  xOut[i, :, :] = x
  yOut[i, :, :] = y
  zOut[i, :, :] = z

fIn.close()
fOut.close()


