#
# DOCU: https://www.paraview.org/ParaView/Doc/Nightly/www/py-doc/paraview.simple.html
#
#### import the simple module from the paraview
import xml.etree.ElementTree as ET
import time
import sys
from paraview.simple import *


def assignCameraParametersToKeyframe(root, keyFrame, camIdx):
   keyFrame.Position=[float(root[camIdx-1][1][0][0][0][0].attrib['value']), float(root[camIdx-1][1][0][0][0][1].attrib['value']), float(root[camIdx-1][1][0][0][0][2].attrib['value'])]
   keyFrame.FocalPoint=[float(root[camIdx-1][1][0][0][1][0].attrib['value']), float(root[camIdx-1][1][0][0][1][1].attrib['value']), float(root[camIdx-1][1][0][0][1][2].attrib['value'])]
   keyFrame.ViewUp=[float(root[camIdx-1][1][0][0][2][0].attrib['value']), float(root[camIdx-1][1][0][0][2][1].attrib['value']), float(root[camIdx-1][1][0][0][2][2].attrib['value'])]
   keyFrame.ParallelScale= float(root[camIdx-1][1][0][0][6][0].attrib['value'])

def assignCameraParameters(root, camera, camIdx):
   camera.SetPosition(float(root[camIdx-1][1][0][0][0][0].attrib['value']), float(root[camIdx-1][1][0][0][0][1].attrib['value']), float(root[camIdx-1][1][0][0][0][2].attrib['value']))
   camera.SetFocalPoint(float(root[camIdx-1][1][0][0][1][0].attrib['value']), float(root[camIdx-1][1][0][0][1][1].attrib['value']), float(root[camIdx-1][1][0][0][1][2].attrib['value']))
   camera.SetViewUp(float(root[camIdx-1][1][0][0][2][0].attrib['value']), float(root[camIdx-1][1][0][0][2][1].attrib['value']), float(root[camIdx-1][1][0][0][2][2].attrib['value']))
   camera.SetParallelScale(float(root[camIdx-1][1][0][0][6][0].attrib['value']))


if len(sys.argv)  < 2:
  attribute = "vo"
else:
  attribute = sys.argv[1]

print "rendering attribute: " + attribute

#Connect()
Connect('localhost')

#### disable automatic camera reset on 'Show'
paraview.simple._DisableFirstRenderCameraReset()

# get active view
renderView = GetActiveViewOrCreate('RenderView')

# create a new 'XDMF Reader'
filename = "./structuredgrid_201709.xdmf"

#
# read 3D volume grid
#
print "reading " + filename
structuredGridxdmf = XDMFReader(FileNames=[filename])
structuredGridxdmf.PointArrayStatus = [attribute]
structuredGridxdmf.GridStatus = ['Timestep_000', 'Timestep_001', 'Timestep_002', 'Timestep_003', 'Timestep_004', 'Timestep_005', 'Timestep_006', 'Timestep_007', 'Timestep_008', 'Timestep_009', 'Timestep_010', 'Timestep_011', 'Timestep_012', 'Timestep_013', 'Timestep_014', 'Timestep_015', 'Timestep_016', 'Timestep_017', 'Timestep_018', 'Timestep_019', 'Timestep_020', 'Timestep_021', 'Timestep_022', 'Timestep_023', 'Timestep_024', 'Timestep_025', 'Timestep_026', 'Timestep_027', 'Timestep_028', 'Timestep_029', 'Timestep_030', 'Timestep_031', 'Timestep_032', 'Timestep_033', 'Timestep_034', 'Timestep_035', 'Timestep_036', 'Timestep_037', 'Timestep_038', 'Timestep_039', 'Timestep_040', 'Timestep_041', 'Timestep_042', 'Timestep_043', 'Timestep_044', 'Timestep_045', 'Timestep_046', 'Timestep_047', 'Timestep_048', 'Timestep_049', 'Timestep_050', 'Timestep_051', 'Timestep_052', 'Timestep_053', 'Timestep_054', 'Timestep_055', 'Timestep_056', 'Timestep_057', 'Timestep_058', 'Timestep_059', 'Timestep_060', 'Timestep_061', 'Timestep_062', 'Timestep_063', 'Timestep_064', 'Timestep_065', 'Timestep_066', 'Timestep_067', 'Timestep_068', 'Timestep_069', 'Timestep_070', 'Timestep_071', 'Timestep_072', 'Timestep_073', 'Timestep_074', 'Timestep_075', 'Timestep_076', 'Timestep_077', 'Timestep_078', 'Timestep_079', 'Timestep_080', 'Timestep_081', 'Timestep_082', 'Timestep_083', 'Timestep_084', 'Timestep_085', 'Timestep_086', 'Timestep_087', 'Timestep_088', 'Timestep_089', 'Timestep_090', 'Timestep_091', 'Timestep_092', 'Timestep_093', 'Timestep_094', 'Timestep_095', 'Timestep_096', 'Timestep_097', 'Timestep_098', 'Timestep_099', 'Timestep_100', 'Timestep_101', 'Timestep_102', 'Timestep_103', 'Timestep_104', 'Timestep_105', 'Timestep_106', 'Timestep_107', 'Timestep_108', 'Timestep_109', 'Timestep_110', 'Timestep_111', 'Timestep_112', 'Timestep_113', 'Timestep_114', 'Timestep_115', 'Timestep_116', 'Timestep_117', 'Timestep_118', 'Timestep_119', 'Timestep_120', 'Timestep_121', 'Timestep_122', 'Timestep_123', 'Timestep_124', 'Timestep_125', 'Timestep_126', 'Timestep_127', 'Timestep_128', 'Timestep_129', 'Timestep_130', 'Timestep_131', 'Timestep_132', 'Timestep_133', 'Timestep_134', 'Timestep_135', 'Timestep_136', 'Timestep_137', 'Timestep_138', 'Timestep_139', 'Timestep_140', 'Timestep_141', 'Timestep_142', 'Timestep_143', 'Timestep_144', 'Timestep_145', 'Timestep_146', 'Timestep_147', 'Timestep_148', 'Timestep_149', 'Timestep_150', 'Timestep_151', 'Timestep_152', 'Timestep_153', 'Timestep_154', 'Timestep_155', 'Timestep_156', 'Timestep_157', 'Timestep_158', 'Timestep_159', 'Timestep_160', 'Timestep_161', 'Timestep_162', 'Timestep_163', 'Timestep_164', 'Timestep_165', 'Timestep_166', 'Timestep_167', 'Timestep_168', 'Timestep_169', 'Timestep_170', 'Timestep_171', 'Timestep_172', 'Timestep_173', 'Timestep_174', 'Timestep_175', 'Timestep_176', 'Timestep_177', 'Timestep_178', 'Timestep_179', 'Timestep_180', 'Timestep_181', 'Timestep_182', 'Timestep_183', 'Timestep_184', 'Timestep_185', 'Timestep_186', 'Timestep_187', 'Timestep_188', 'Timestep_189', 'Timestep_190', 'Timestep_191', 'Timestep_192', 'Timestep_193', 'Timestep_194', 'Timestep_195', 'Timestep_196', 'Timestep_197', 'Timestep_198', 'Timestep_199', 'Timestep_200', 'Timestep_201', 'Timestep_202', 'Timestep_203', 'Timestep_204', 'Timestep_205', 'Timestep_206', 'Timestep_207', 'Timestep_208', 'Timestep_209', 'Timestep_210', 'Timestep_211', 'Timestep_212', 'Timestep_213', 'Timestep_214', 'Timestep_215', 'Timestep_216', 'Timestep_217', 'Timestep_218', 'Timestep_219', 'Timestep_220', 'Timestep_221', 'Timestep_222', 'Timestep_223', 'Timestep_224', 'Timestep_225', 'Timestep_226', 'Timestep_227', 'Timestep_228', 'Timestep_229', 'Timestep_230', 'Timestep_231', 'Timestep_232', 'Timestep_233', 'Timestep_234', 'Timestep_235', 'Timestep_236', 'Timestep_237', 'Timestep_238', 'Timestep_239', 'Timestep_240', 'Timestep_241', 'Timestep_242', 'Timestep_243', 'Timestep_244', 'Timestep_245', 'Timestep_246', 'Timestep_247', 'Timestep_248', 'Timestep_249', 'Timestep_250', 'Timestep_251', 'Timestep_252', 'Timestep_253', 'Timestep_254', 'Timestep_255', 'Timestep_256', 'Timestep_257', 'Timestep_258', 'Timestep_259', 'Timestep_260', 'Timestep_261', 'Timestep_262', 'Timestep_263', 'Timestep_264', 'Timestep_265', 'Timestep_266', 'Timestep_267', 'Timestep_268', 'Timestep_269', 'Timestep_270', 'Timestep_271', 'Timestep_272', 'Timestep_273', 'Timestep_274', 'Timestep_275', 'Timestep_276', 'Timestep_277', 'Timestep_278', 'Timestep_279', 'Timestep_280', 'Timestep_281', 'Timestep_282', 'Timestep_283', 'Timestep_284', 'Timestep_285', 'Timestep_286', 'Timestep_287', 'Timestep_288', 'Timestep_289', 'Timestep_290', 'Timestep_291', 'Timestep_292', 'Timestep_293', 'Timestep_294', 'Timestep_295', 'Timestep_296', 'Timestep_297', 'Timestep_298', 'Timestep_299', 'Timestep_300', 'Timestep_301', 'Timestep_302', 'Timestep_303', 'Timestep_304', 'Timestep_305', 'Timestep_306', 'Timestep_307', 'Timestep_308', 'Timestep_309', 'Timestep_310', 'Timestep_311', 'Timestep_312', 'Timestep_313', 'Timestep_314', 'Timestep_315', 'Timestep_316', 'Timestep_317', 'Timestep_318', 'Timestep_319', 'Timestep_320', 'Timestep_321', 'Timestep_322', 'Timestep_323', 'Timestep_324', 'Timestep_325', 'Timestep_326', 'Timestep_327', 'Timestep_328', 'Timestep_329', 'Timestep_330', 'Timestep_331', 'Timestep_332', 'Timestep_333', 'Timestep_334', 'Timestep_335', 'Timestep_336', 'Timestep_337', 'Timestep_338', 'Timestep_339', 'Timestep_340', 'Timestep_341', 'Timestep_342', 'Timestep_343', 'Timestep_344', 'Timestep_345', 'Timestep_346', 'Timestep_347', 'Timestep_348', 'Timestep_349', 'Timestep_350', 'Timestep_351', 'Timestep_352', 'Timestep_353', 'Timestep_354', 'Timestep_355', 'Timestep_356', 'Timestep_357', 'Timestep_358', 'Timestep_359', 'Timestep_360', 'Timestep_361', 'Timestep_362', 'Timestep_363', 'Timestep_364', 'Timestep_365', 'Timestep_366', 'Timestep_367', 'Timestep_368', 'Timestep_369', 'Timestep_370', 'Timestep_371', 'Timestep_372', 'Timestep_373', 'Timestep_374', 'Timestep_375', 'Timestep_376', 'Timestep_377', 'Timestep_378', 'Timestep_379', 'Timestep_380', 'Timestep_381', 'Timestep_382', 'Timestep_383', 'Timestep_384', 'Timestep_385', 'Timestep_386', 'Timestep_387', 'Timestep_388', 'Timestep_389', 'Timestep_390', 'Timestep_391', 'Timestep_392', 'Timestep_393', 'Timestep_394', 'Timestep_395', 'Timestep_396', 'Timestep_397', 'Timestep_398', 'Timestep_399', 'Timestep_400', 'Timestep_401', 'Timestep_402', 'Timestep_403', 'Timestep_404', 'Timestep_405', 'Timestep_406', 'Timestep_407', 'Timestep_408', 'Timestep_409', 'Timestep_410', 'Timestep_411', 'Timestep_412', 'Timestep_413', 'Timestep_414', 'Timestep_415', 'Timestep_416', 'Timestep_417', 'Timestep_418', 'Timestep_419', 'Timestep_420', 'Timestep_421', 'Timestep_422', 'Timestep_423', 'Timestep_424', 'Timestep_425', 'Timestep_426', 'Timestep_427', 'Timestep_428', 'Timestep_429', 'Timestep_430', 'Timestep_431', 'Timestep_432', 'Timestep_433', 'Timestep_434', 'Timestep_435', 'Timestep_436', 'Timestep_437', 'Timestep_438', 'Timestep_439', 'Timestep_440', 'Timestep_441', 'Timestep_442', 'Timestep_443', 'Timestep_444', 'Timestep_445', 'Timestep_446', 'Timestep_447', 'Timestep_448', 'Timestep_449', 'Timestep_450', 'Timestep_451', 'Timestep_452', 'Timestep_453', 'Timestep_454', 'Timestep_455', 'Timestep_456', 'Timestep_457', 'Timestep_458', 'Timestep_459', 'Timestep_460', 'Timestep_461', 'Timestep_462', 'Timestep_463', 'Timestep_464', 'Timestep_465', 'Timestep_466', 'Timestep_467', 'Timestep_468', 'Timestep_469', 'Timestep_470', 'Timestep_471', 'Timestep_472', 'Timestep_473', 'Timestep_474', 'Timestep_475', 'Timestep_476', 'Timestep_477', 'Timestep_478', 'Timestep_479', 'Timestep_480', 'Timestep_481', 'Timestep_482', 'Timestep_483', 'Timestep_484', 'Timestep_485', 'Timestep_486', 'Timestep_487', 'Timestep_488', 'Timestep_489', 'Timestep_490', 'Timestep_491', 'Timestep_492', 'Timestep_493', 'Timestep_494', 'Timestep_495', 'Timestep_496', 'Timestep_497', 'Timestep_498', 'Timestep_499', 'Timestep_500', 'Timestep_501', 'Timestep_502', 'Timestep_503', 'Timestep_504', 'Timestep_505', 'Timestep_506', 'Timestep_507', 'Timestep_508', 'Timestep_509', 'Timestep_510', 'Timestep_511', 'Timestep_512', 'Timestep_513', 'Timestep_514', 'Timestep_515', 'Timestep_516', 'Timestep_517', 'Timestep_518', 'Timestep_519', 'Timestep_520', 'Timestep_521', 'Timestep_522', 'Timestep_523', 'Timestep_524', 'Timestep_525', 'Timestep_526', 'Timestep_527', 'Timestep_528', 'Timestep_529', 'Timestep_530', 'Timestep_531', 'Timestep_532', 'Timestep_533', 'Timestep_534', 'Timestep_535', 'Timestep_536', 'Timestep_537', 'Timestep_538', 'Timestep_539', 'Timestep_540', 'Timestep_541', 'Timestep_542', 'Timestep_543', 'Timestep_544', 'Timestep_545', 'Timestep_546', 'Timestep_547', 'Timestep_548', 'Timestep_549', 'Timestep_550', 'Timestep_551', 'Timestep_552', 'Timestep_553', 'Timestep_554', 'Timestep_555', 'Timestep_556', 'Timestep_557', 'Timestep_558', 'Timestep_559', 'Timestep_560', 'Timestep_561', 'Timestep_562', 'Timestep_563', 'Timestep_564', 'Timestep_565', 'Timestep_566', 'Timestep_567', 'Timestep_568', 'Timestep_569', 'Timestep_570', 'Timestep_571', 'Timestep_572', 'Timestep_573', 'Timestep_574', 'Timestep_575', 'Timestep_576', 'Timestep_577', 'Timestep_578', 'Timestep_579', 'Timestep_580', 'Timestep_581', 'Timestep_582', 'Timestep_583', 'Timestep_584', 'Timestep_585', 'Timestep_586', 'Timestep_587', 'Timestep_588', 'Timestep_589', 'Timestep_590', 'Timestep_591', 'Timestep_592', 'Timestep_593', 'Timestep_594', 'Timestep_595', 'Timestep_596', 'Timestep_597', 'Timestep_598', 'Timestep_599', 'Timestep_600', 'Timestep_601', 'Timestep_602', 'Timestep_603', 'Timestep_604', 'Timestep_605', 'Timestep_606', 'Timestep_607', 'Timestep_608', 'Timestep_609', 'Timestep_610', 'Timestep_611', 'Timestep_612', 'Timestep_613', 'Timestep_614', 'Timestep_615', 'Timestep_616', 'Timestep_617', 'Timestep_618', 'Timestep_619', 'Timestep_620', 'Timestep_621', 'Timestep_622', 'Timestep_623', 'Timestep_624', 'Timestep_625', 'Timestep_626', 'Timestep_627', 'Timestep_628', 'Timestep_629', 'Timestep_630', 'Timestep_631', 'Timestep_632', 'Timestep_633', 'Timestep_634', 'Timestep_635', 'Timestep_636', 'Timestep_637', 'Timestep_638', 'Timestep_639', 'Timestep_640', 'Timestep_641', 'Timestep_642', 'Timestep_643', 'Timestep_644', 'Timestep_645', 'Timestep_646', 'Timestep_647', 'Timestep_648', 'Timestep_649', 'Timestep_650', 'Timestep_651', 'Timestep_652', 'Timestep_653', 'Timestep_654', 'Timestep_655', 'Timestep_656', 'Timestep_657', 'Timestep_658', 'Timestep_659', 'Timestep_660', 'Timestep_661', 'Timestep_662', 'Timestep_663', 'Timestep_664', 'Timestep_665', 'Timestep_666', 'Timestep_667', 'Timestep_668', 'Timestep_669', 'Timestep_670', 'Timestep_671', 'Timestep_672', 'Timestep_673', 'Timestep_674', 'Timestep_675', 'Timestep_676', 'Timestep_677', 'Timestep_678', 'Timestep_679', 'Timestep_680', 'Timestep_681', 'Timestep_682', 'Timestep_683', 'Timestep_684', 'Timestep_685', 'Timestep_686', 'Timestep_687', 'Timestep_688', 'Timestep_689', 'Timestep_690', 'Timestep_691', 'Timestep_692', 'Timestep_693', 'Timestep_694', 'Timestep_695', 'Timestep_696', 'Timestep_697', 'Timestep_698', 'Timestep_699', 'Timestep_700', 'Timestep_701', 'Timestep_702', 'Timestep_703', 'Timestep_704', 'Timestep_705', 'Timestep_706', 'Timestep_707', 'Timestep_708', 'Timestep_709']

# show data in view
structuredGridxdmfDisplay = Show(structuredGridxdmf, renderView)
# trace defaults for the display properties.
structuredGridxdmfDisplay.Representation = 'Outline'
Hide(structuredGridxdmf, renderView)

#
# resampleToImage
#
print "resampleToImage"
resampleToImage = ResampleToImage(Input=structuredGridxdmf)
resampleToImage.SamplingBounds = [-217.9999542236328, 218.0, -217.99964904785156, 217.99940490722656, -217.99993896484375, 217.99993896484375]
resampleToImage.SamplingDimensions = [600, 600, 600]
# show data in view
resampleToImageDisplay = Show(resampleToImage, renderView)
resampleToImageDisplay.SetRepresentationType('Volume')
resampleToImageDisplay.VolumeRenderingMode = 'OSPRay Based'
# set scalar coloring
ColorBy(resampleToImageDisplay, ('POINTS', attribute))

# Properties modified on renderView
renderView.EnableOSPRay = 1
renderView.Shadows = 1
renderView.SamplesPerPixel = 10
renderView.LightScale = 1.4

#
# setup Look Up Tables
#
ImportPresets(filename='./stein_' + attribute + '.json')
LUT = GetColorTransferFunction(attribute)
LUT.NumberOfTableValues = 1024
LUT.ApplyPreset('stein_'+attribute, True)
PWF = GetOpacityTransferFunction(attribute)
PWF.ApplyPreset('stein_'+attribute, True)
resampleToImageDisplay.RescaleTransferFunctionToDataRange(True, False)
if attribute == "clwc":
  LUT.RescaleTransferFunction(0.0, 0.0001)
  PWF.RescaleTransferFunction(0.0, 0.0001)
elif attribute == "ciwc":
  LUT.RescaleTransferFunction(0.0, 0.00069)
  PWF.RescaleTransferFunction(0.0, 0.00069)
elif attribute == "q":
  LUT.RescaleTransferFunction(0.0, 0.0237065)
  PWF.RescaleTransferFunction(0.0, 0.0237065)
elif attribute == "cc":
  LUT.RescaleTransferFunction(0.0, 1.0)
  PWF.RescaleTransferFunction(0.0, 1.0)


#
# create a new 'Sphere'
#
sphere = Sphere()
sphere.Radius = 150.0
sphere.ThetaResolution = 100
sphere.EndTheta = 359.9999
sphere.PhiResolution = 50
sphereDisplay = Show(sphere, renderView)
Hide(sphere)

#
# create a new 'Texture Map to Sphere'
#
textureMaptoSphere = TextureMaptoSphere(Input=sphere)
textureMaptoSphere.PreventSeam = 0
textureMaptoSphereDisplay = Show(textureMaptoSphere, renderView)
textureMaptoSphereDisplay.Representation = 'Surface'
texProxy = servermanager.CreateProxy("textures", "ImageTexture")
texProxy.GetProperty("FileName").SetElement(0, "./earth_heller_transformed.jpg")
texProxy.UpdateVTKObjects()
textureMaptoSphereDisplay.Texture= texProxy
# Hide orientation axes
renderView.OrientationAxesVisibility = 0

# current camera placement for renderView1
#renderView.CameraPosition = [-269.74750344641296, -952.2832441659983, 165.39792467190958]
#renderView.CameraViewUp = [0.2113306328188308, 0.10884464044232195, 0.9713352705834244]
#renderView.CameraParallelScale = 259.7186335134578

tree = ET.parse('camera_' + attribute + '.pvcvbc')
root = tree.getroot()
camera = GetActiveCamera()
assignCameraParameters(root, camera, 1)
#camera.SetPosition(-269.74750344641296, -952.2832441659983, 165.39792467190958)
#camera.SetFocalPoint(0.0, 0.0, 0.0)
#camera.SetViewUp(0.0, 0.0, 1.0)

# full HD
imageresolution =  [1920, 1080]
# 4K
#imageresolution =  [3840, 2160]

#renderView.Update()
#SaveScreenshot('./test.jpg', renderView, ImageResolution=imageresolution)
#quit()

picDirName = "./image_"
#
# setup first animation scene
#
animationScene = GetAnimationScene()
timeKeeper=GetTimeKeeper()
timeTrack = GetTimeTrack()
# get camera animation track for the view
cameraAnimationCue = GetCameraTrack(view=renderView)

# create a key frame
keyFrame1 = CameraKeyFrame()
keyFrame1.Position = [-65.4127430002334, -801.670821153378, 304.703120661567]
keyFrame1.FocalPoint = [-2.78451391117126, -34.1262063635407, 12.9708175588801]
keyFrame1.ViewUp = [0.0459417216943242, 0.351634527009914, 0.93500936766552]
keyFrame1.ParallelScale = 377.586754497372
keyFrame1.PositionPathPoints = [-65.4127, -801.671, 304.703, 624.6261817973191, -562.9183852436468, 181.00864520157754, 851.5926803464816, 93.15869986795698, -76.8785971774956, 447.2230897935052, 680.1714606341476, -277.7716428205982, -288.69946646658116, 762.9325758357912, -272.7365805281454, -810.5920176895919, 280.0863298344386, -65.50620014334936, -731.5447102728301, -410.4047620682397, 190.28734560653072]
keyFrame1.FocalPathPoints = [2.28882e-05, -0.00012207, 0.0]
keyFrame1.ClosedPositionPath = 1

# create a key frame
keyFrame2 = CameraKeyFrame()
keyFrame2.KeyTime = 1.0
keyFrame2.Position = [-65.4127430002334, -801.670821153378, 304.703120661567]
keyFrame2.FocalPoint = [-2.78451391117126, -34.1262063635407, 12.9708175588801]
keyFrame2.ViewUp = [0.0459417216943242, 0.351634527009914, 0.93500936766552]
keyFrame2.ParallelScale = 377.586754497372

# initialize the animation track
cameraAnimationCue.Mode = 'Path-based'
cameraAnimationCue.KeyFrames = [keyFrame1, keyFrame2]
cameraAnimationCue.Enabled = 0
numFrames = 360
numRenderedImages = 0
renderFlight = 0

if len(sys.argv) == 4:
  start = int(sys.argv[2])
  end = int(start + int(sys.argv[3]))
#  if end > len(timeKeeper.TimestepValues)-1: #skip last data file, it is empty
#    end = int(len(timeKeeper.TimestepValues)-1)
#else:
#  start = int(0)
#  end = int(len(timeKeeper.TimestepValues)-1)
  if end > 696:
    end = 696
else:
  start = int(0)
  end = 696

numFramesTotal = ((end - start) + numFrames*renderFlight)
 


animationScene.PlayMode = 'Snap To TimeSteps'
animationScene.StartTime = timeKeeper.TimestepValues[start]
animationScene.EndTime   = timeKeeper.TimestepValues[end-1]
timeTrack.UseAnimationTime = 1
animationScene.GoToFirst()
print "rendering from %d to %d" % (start, end)

startTime = time.time()
for t in range(start, end):
  #renderView.Update()
  picName = picDirName + attribute + "_%04d.jpg" % (t)
  out = "saving image %d of %d: "  % (numRenderedImages+1, numFramesTotal)
  print out + picName
  print "time: %f" % (timeKeeper.Time)
  SaveScreenshot(picName, renderView, ImageResolution=imageresolution)
  animationScene.GoToNext()
  numRenderedImages = numRenderedImages + 1
  d = (time.time()-startTime)/numRenderedImages # average duration per image in seconds
  print "estimated remaining time: %d minutes" % (int(d/60.0 * (numFramesTotal-numRenderedImages)))
if renderFlight == 1:
  timeTrack.UseAnimationTime = 0
  cameraAnimationCue.Enabled = 1
  animationScene.PlayMode = 'Sequence'
  animationScene.AnimationTime = float(timeKeeper.TimestepValues[-1])
  animationScene.StartTime = float(timeKeeper.TimestepValues[-1])          # last timestep
  animationScene.EndTime   = float(timeKeeper.TimestepValues[-1]) + 10.0   # last timestep + 10.0
  animationScene.NumberOfFrames = numFrames
  animationScene.GoToFirst()
  for t in range(numFrames):
    #renderView.Update()
    picName = picDirName + attribute + "_flight_%04d.jpg" % (t)
    out = "saving image %d of %d: "  % (numRenderedImages+1, numFramesTotal)
    print out + picName
    print "time: %f" % (timeKeeper.Time)
    SaveScreenshot(picName, renderView, ImageResolution=imageresolution)
    animationScene.GoToNext()
    numRenderedImages = numRenderedImages + 1
    d = (time.time()-startTime) / numRenderedImages # average duration per image in seconds
    print "estimated remaining time: %d minutes" % (int(d/60.0 * (numFramesTotal-numRenderedImages)))

  
